extends KinematicBody2D

const SimpleGunShot = preload("res://assets/misc/SimpleGunShot.tscn")

export var ACCELERATION: int = 700
export var MAX_SPEED: int = 150
export var ROLL_SPEED: int = 120
export var FRICTION: int = 550

var _velocity: Vector2 = Vector2.ZERO

func _physics_process(delta: float) -> void:
	if Input.is_action_just_pressed("shoot"):
		shoot()
	move(delta)

func shoot() -> void:
	var simpleGunShot := SimpleGunShot.instance()
	var gunShot := get_node("GunShot")
	simpleGunShot.position = gunShot.get_global_position()
	get_tree().current_scene.add_child(simpleGunShot)

func move(delta: float) -> void:
	var input_vector := Vector2.ZERO
	input_vector.x = Input.get_action_strength("ui_right") - Input.get_action_strength("ui_left")
	input_vector.y = Input.get_action_strength("ui_down") - Input.get_action_strength("ui_up")
	input_vector = input_vector.normalized()
	
	if input_vector != Vector2.ZERO:
		input_vector = _velocity.move_toward(input_vector * MAX_SPEED, ACCELERATION * delta)
	else:
		input_vector = _velocity.move_toward(Vector2.ZERO, FRICTION * delta)
	
	_velocity = move_and_slide(input_vector)
